﻿Imports SQLCompact004.MP3Files
Imports System.Data.SqlServerCe
Imports System.Data.Objects
Imports System.Data.EntityClient
Imports System.Data.Entity
Imports System.Data.Entity.Infrastructure
Imports System.IO
Imports System.Security.Cryptography
Imports System.Text

Public Class Form1

    'Pfad zur DB
    Private Const strConn As String = "Data Source=d:\DbFile001.sdf"
    'Pfad zu MP3-Dateien
    Private Const strFilePath As String = "E:\MP3\unique"

    Private oConn As New SqlCeConnectionStringBuilder(strConn)

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim strHash As String = Nothing

        Using fc As New DateiContext(oConn.ToString(), "System.Data.SqlServerCe.4.0")
            fc.Database.CreateIfNotExists()

            Dim Dir As FileInfo() = New DirectoryInfo(strFilePath).GetFiles("*.mp3", SearchOption.AllDirectories)

            For Each datei As FileInfo In Dir
                Try

                    strHash = Nothing
                    Using fstream As FileStream = New FileStream(
                            datei.FullName _
                            , FileMode.Open _
                            , FileAccess.Read _
                            , FileShare.Read
                    )

                        Dim hash() As Byte = New MD5CryptoServiceProvider().ComputeHash(fstream)

                        Dim sb As New StringBuilder(hash.Length * 2)

                        For Each hex As Byte In hash
                            sb.Append(hex.ToString("X2"))
                        Next
                        strHash = sb.ToString

                    End Using

                    fc.Dateien.Add(New Datei With {
                            .datum = datei.LastWriteTime _
                            , .pfad = datei.DirectoryName _
                            , .name = datei.Name _
                            , .md5 = strHash _
                            , .size = datei.Length
                    })

                Catch ex As Exception
                    Debug.Print(ex.Message)

                End Try

            Next

            fc.SaveChanges()

        End Using

    End Sub

    Public Sub New()

        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        Database.SetInitializer(Of DateiContext)(New MyDbInitializer())

        'Database.DefaultConnectionFactory = New SqlCeConnectionFactory("System.Data.SqlServerCe.4.0", "d:\", strConn)

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        Using fc As New DateiContext(oConn.ToString(), "System.Data.SqlServerCe.4.0")
            fc.Database.CreateIfNotExists()

            Try
                Dim o = From b In (
                        From a In fc.Dateien
                        Group a By Size = a.size, MD5 = a.md5 Into g = Group
                        Select New With {.size = Size, .md5 = MD5, .anz = g.Count()}
                    )
                    Join c In fc.Dateien _
                    On b.size Equals c.size _
                    And b.md5 Equals c.md5
                    Where b.anz > 1
                    Order By b.anz Descending
                    Select New With {.name = c.name, .pfad = c.pfad, .size = c.size, .anz = b.anz}

                For Each s In o
                    Debug.Print(s.name)
                Next

            Catch ex As Exception
                Debug.Print(ex.Message)
            End Try

        End Using

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        Using fc As New DateiContext(oConn.ToString(), "System.Data.SqlServerCe.4.0")
            fc.Database.CreateIfNotExists()

            Try
                Dim o As DbQuery(Of Datei) = From a In fc.Dateien
                                                Order By a.pfad, a.name
                                                Select a

                For Each s In o
                    Debug.Print(String.Format("{0} \ {1} => {2}", New String() {s.pfad, s.name, s.md5}))
                Next

            Catch ex As Exception
                Debug.Print(ex.Message)
            End Try

        End Using
    End Sub
End Class
